/*
Copyright (C) Cay S. Horstmann 2017

This file is part of the Big C++ media utilities.

The Big C++ media utilities are free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The Big C++ media utilities are distributed in the hope that they will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the Big C++ media utilities. If not, see <https://www.gnu.org/licenses/>. 
*/

#include <string>
#include <vector>
#include "picture.h"
#include "jo_gif.h"

using namespace std;

class Animation
{
 public:
   /**
      Constructs an object for creating an animation.
      @param filename the name of the animated GIF file 
      @param width the width of the animated image
      @param height the height of the animated image
    */
   Animation(string filename, int width, int height);
   /**
      Add a picture to the current frame.
   */
   void add(const Picture& pic, int width, int height);
   /**
      Start a new frame.
   */
   void frame();
   /**
      Close the animation.
   */
   // void close();
   ~Animation();
 private:
   jo_gif_t _gif;
   vector<unsigned char> _frame;
   int _width;
   int _height;   
};

